#!/bin/bash

read  -p "Insert filename for load to MEM (default $loadbin):"  loadbinnew
read -p "Continue? (Y/N): " confirm && [[ $confirm == [yY] || $confirm == [yY][eE][sS] ]] || exit 1
if [ "$loadbinnew" == "" ]
then
echo  "FileName = " $loadbin >>.default
else
   loadbin="$loadbinnew"
echo  "FileName = " $loadbin >>.default
fi

filesize=$(stat -c%s "$loadbin")
if (( filesize % 4 != 0 )); then
    echo "Error: File size must be a multiple of 4 bytes. Current size: $filesize bytes."
    exit 1
fi

writescript=$(basename $loadbin)".sh"

echo "WRITESCRIPT=$writescript"

read -p "Insert address to write:"  pradr
read -p "Insert bus address:" badr
read -p "Insert place to write 0 (boot) 1 (programm):" bp

echo "#!/bin/bash" >> $writescript
echo "" >> $writescript
echo "echo 'Start'" >> $writescript
echo "modprobe i2c-dev" >> $writescript
echo "modprobe i2c-i801" >> $writescript

crc1=$(crc32 $loadbin |awk '{print substr($0,1,2)}')
crc2=$(crc32 $loadbin |awk '{print substr($0,3,2)}')
crc3=$(crc32 $loadbin |awk '{print substr($0,5,2)}')
crc4=$(crc32 $loadbin |awk '{print substr($0,7,2)}')

xxd -g 1 "$loadbin" | cut -d':' -f2 | cut -d' ' -f1-17 | while read -r line; do
    byte_array=($line)
    byte_count=${#byte_array[@]} 
    
    cmd="i2cset -f -a -y $badr 0x$pradr 0x8"
    for (( i = 0; i < byte_count; i++ )); do
        cmd+=" 0x${byte_array[$i]}"
    done
    cmd+=" i"
    
    echo "$cmd" >> "$writescript"
    echo "sleep 0.01" >> "$writescript"
done

echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc4" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc3" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc2" >> $writescript
echo "sleep 0.1" >> $writescript
echo "i2cset -f -y $badr "0x"$pradr 0x8 "0x"$crc1" >> $writescript
echo "sleep 0.1" >> $writescript

echo "echo 'Done'" >>$writescript
echo "sleep 0.1" >> $writescript
if [ "$bp" -eq 0 ]
then
echo "i2cset -f -y $badr "0x"$pradr 0xa 0xbb" >> $writescript
fi
if [ "$bp" -eq 1 ]
then
echo "i2cset -f -y $badr "0x"$pradr 0xa 0xaa" >> $writescript
fi
chmod +x $writescript

